Prime Path POJ

来源:互联网 发布:安全风险评估矩阵 编辑:程序博客网 时间:2024/06/11 07:20

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0

将一个四位数逐位换成另一个四位数,不能有前导零,变换过程中的数也必须是质数。
先将质数打表,再BFS搜索,换掉一位数还是质数则加入下一层

#include <string.h>#include <iostream>#include <queue>#include <stdio.h>using namespace std;int pr[10001];int vis[10001];int dis[10001];int mo[4]={1,10,100,1000};void table(){    for(int i=2;i<=10000;i++){        if(pr[i]){            for(int j=2*i;j<=10000;j+=i){                if(pr[j]){                    pr[j]=0;                }            }        }    }}int bfs(int a,int b){    if(a==b){        return 0;    }    queue<int> q;    dis[a]=0;vis[a]=1;    q.push(a);    int w[4];    int x,y,t,s;    while(!q.empty()){        x=q.front();        //cout<<x<<' '<<dis[x]<<endl;        q.pop();        if(x==b){            return dis[b];        }        y=dis[x];        for(int i=0;i<4;i++){            w[i]=x%10;            x/=10;        }        for(int i=0;i<4;i++){            for(int j=1;j<=9;j++){                t=(w[i]+j)%10;                if(i==3&&t==0)                    continue;                s=0;                for(int k=0;k<4;k++){                    if(k==i){                        s+=t*mo[k];                    }else{                        s+=w[k]*mo[k];                    }                }                if(pr[s]&&!vis[s]){                    vis[s]=1;                    dis[s]=y+1;                    q.push(s);                }            }        }    }    return -1;}int main(){    int T,a,b,k;    scanf("%d",&T);    memset(pr,1,sizeof(pr));    table();    while(T--){        memset(vis,0,sizeof(vis));        scanf("%d %d",&a,&b);        k=bfs(a,b);        if(k==-1){            printf("Impossible\n");        }else{            printf("%d\n",k);        }    }    return 0;}
原创粉丝点击